******************************************************************
*                                                                 
*      CALLED BY FTPDHS TO VERIFY RECORD COUNTS
*
******************************************************************
******************************************************************
 IDENTIFICATION DIVISION.
 PROGRAM-ID. PSMRTVFY.                                            
 ENVIRONMENT DIVISION.
 CONFIGURATION SECTION.                                  
 SOURCE-COMPUTER. IBM-PC.
 OBJECT-COMPUTER. IBM-PC.
 INPUT-OUTPUT SECTION.                                  
 FILE-CONTROL.     
 
     SELECT SETTINGS
         ASSIGN TO VARYING WS-SETTINGS-FNAME
         ACCESS IS SEQUENTIAL
         FILE STATUS IS IO-STATUS.

     SELECT INSBFILE
         ASSIGN TO VARYING WS-PSMRTFBL-PATH
         FILE STATUS IS IO-STATUS.


 I-O-CONTROL.
 DATA DIVISION.
 FILE SECTION. 
 
 FD  SETTINGS         
     LABEL RECORDS ARE STANDARD.
 01  SETTINGS-REC.
     03  FILETYPE-DESCRIPTIONS         PIC X(180).
     03  FILE-DEFINITIONS              PIC X(1945).              
     03  SAVE-BACKUP-RESULTS-IND       PIC 9.
     03  SAVE-BACKUP-RESULTS-PATH      PIC X(100).
     03  FILLER                        PIC X(9).  
     03  SAVE-PROVIDER-ID              PIC X(8).
     03  SAVE-LAST-FTPUSER             PIC X(8).
     03  SAVE-PRI-EMAIL-ADDRESS        PIC X(40).
     03  SAVE-SEC-EMAIL-ADDRESS        PIC X(40).  
     
     03  SAVE-FTP-HOST-NAME            PIC X(30). 
     03  SAVE-FTP-PORT                 PIC 9(04).
     03  SAVE-FTP-SSL                  PIC 9.  
     
     03  FILLER                        PIC X(15).  
     03  SAVE-SEQUENCE                 PIC 9(9). 

 FD INSBFILE
     LABEL RECORDS ARE STANDARD
     RECORD CONTAINS 0 CHARACTERS
     BLOCK CONTAINS 0 CHARACTERS.
 01  TRANS-RECORD                      PIC X(300).
 
 WORKING-STORAGE SECTION.
 01  WORKING-STORAGE-FIELDS.
     
     05  CURRENT-DIRECTORY-PATH.     
         10  DRIVE-LETTER     PIC X.
         10  FILLER           PIC X(259).  
     05  DOWNLOAD-DIRECTORY-PATH  PIC X(100).    
     05  UPLOAD-DIRECTORY-PATH    PIC X(100). 
*     
* <Sleep>
     05  SLEEP-DELAY         PIC  9(9) BINARY VALUE 2000.
* <CreateDirectory> 
     05  SECURITY-ATTRIB     PIC  9(9) BINARY VALUE 0.
     
     05  BUFFER-LENGTH       PIC S9(9) BINARY VALUE 260.     
     
     05  STATUS-CODE         PIC S9(4) BINARY.          
     05  WIN32-RESULT        PIC S9(9) BINARY. 
     05  nResult             PIC S9(9) BINARY. 
*
     05  WS-PSMRTFBL-PATH    PIC X(100).
*         
     05  WS-SETTINGS-FNAME     PIC X(13) VALUE 'FTPDHS.CFG[U]'. 
*
     05  WS-TRANS-PROGRESS     PIC 9(6)V999 BINARY. 
     05  WS-TOTAL-RECORDS      PIC 9(6) VALUE 0.     
     05  WS-RECORD-COUNT       PIC 9(6) VALUE 0.  
     05  WS-TRAILER-COUNT      PIC 9(6) VALUE 0.  
     05  WS-SUBMITTAL-COUNT    PIC 9(6) VALUE 0.  
     05  WS-RECORD-COUNT-X     PIC ZZZ,ZZ9.
     05  WS-HOUR-COUNT         PIC 9(6).
     05  WS-MINUTE-COUNT       PIC 9(6).
     05  WS-FILEDESC           PIC X(31).  
*         
 01  HOLD-RETURN-CODE        PIC 9(04).
 01  FILLER REDEFINES HOLD-RETURN-CODE.
     05  FILLER              PIC 9(02).
     05  HOLD-RET-CD         PIC 9(02).
 01  WS-HOLD-FUNCTION        PIC S9(04) BINARY.
*     
 01  HOLD-SUBMIT-DATE.  
     05  SUBMIT-YYYY         PIC X(04).
     05  SUBMIT-MM           PIC X(02).  
     05  SUBMIT-DD           PIC X(02).
*         
 COPY FtpTypes.        
 01   FtpTypes-Screen-Fields REDEFINES FtpTypes-4.
      05 Filetype-Desc OCCURS 6 TIMES   PIC X(30).
*     
 COPY PSMRTFBL.
 COPY IOCODES. 
 COPY TRANSDLG. 
 COPY FTPERROR.
*
 LINKAGE SECTION.            
 01  VERIFICATION-PARAMS.
     05  VER-TRANTYPE            PIC 9.
     05  VER-FILETYPE            PIC 9.  
     05  VER-FILEPATH            PIC X(100).
     05  VER-FILENAME            PIC X(20).   
     05  VER-FILESIZE            PIC 9(9) BINARY.
     05  VER-RESULT              PIC X VALUE SPACE.   
 01  FTPSCRN-DIALOG              PIC X(2000).
* 
 PROCEDURE DIVISION USING VERIFICATION-PARAMS 
                          FTPSCRN-DIALOG. 
                                               
 0100-MAIN.                                    
     PERFORM 9500-INITIALIZATION      THRU 9500-EXIT.
*
     IF VER-FILETYPE = '1'  
       PERFORM 0200-PROCESS-PSMRTFBL  THRU 0200-EXIT
     END-IF  
*     
     PERFORM 9800-TERMINATION         THRU 9800-EXIT. 
     GOBACK.
 0100-EXIT.
     EXIT.
*     
 0200-PROCESS-PSMRTFBL.          
     MOVE ZERO                      TO WS-RECORD-COUNT
                                       WS-SUBMITTAL-COUNT. 
     MOVE SPACES                    TO HOLD-SUBMIT-DATE. 
     STRING VER-FILEPATH DELIMITED BY x'00'          
            '\' DELIMITED BY SIZE  
            VER-FILENAME DELIMITED BY x'00'
            x'00' DELIMITED BY SIZE
                                   INTO WS-PSMRTFBL-PATH.    
     OPEN INPUT INSBFILE. 
     IF NOT SUCCESS
       STRING 'VERIFICATION ERROR: '
              'Opening Student Billing Input file' 
              x'0D0A0D0A' 'Return Code: ' IO-STATUS 
                 DELIMITED BY SIZE INTO FTPERROR-DIALOG
       PERFORM 9000-ERROR-SCREEN    THRU 9000-EXIT         
       PERFORM 9800-TERMINATION     THRU 9800-EXIT 
       MOVE 'E'                     TO VER-RESULT
       GOBACK   
     ELSE  
       SET PSMRTFBL-OPEN            TO TRUE    
       DIVIDE VER-FILESIZE BY 300  GIVING WS-TOTAL-RECORDS ROUNDED
     END-IF.  
     READ INSBFILE.   
     IF END-OF-FILE
       STRING 'VERIFICATION ERROR: '
              'EOF upon reading Student Billing '
              'file' x'0D0A0D0A' 'Return Code: ' IO-STATUS 
                 DELIMITED BY SIZE INTO FTPERROR-DIALOG
       PERFORM 9000-ERROR-SCREEN    THRU 9000-EXIT         
       PERFORM 9800-TERMINATION     THRU 9800-EXIT 
       MOVE 'E'                     TO VER-RESULT
       GOBACK   
     ELSE  
       MOVE TRANS-RECORD      TO BL-SCHOOL-BILLING-RECORD       
     END-IF.  

     PERFORM UNTIL END-OF-FILE OR NOT SUCCESS
       IF SUCCESS                  
         MOVE TRANS-RECORD    TO BL-SCHOOL-BILLING-RECORD 
*         
         ADD 1                     TO WS-RECORD-COUNT     
         IF BL-TRAIL-STUDENT-ID NOT EQUAL ZERO AND 999999999 
           ADD 1                   TO WS-SUBMITTAL-COUNT  
         END-IF  
         
         IF FUNCTION MOD(WS-RECORD-COUNT, 50) = 0
           PERFORM 1000-DISPLAY-PROGRESS   THRU 1000-EXIT
         END-IF  
       ELSE     
         STRING 'VERIFICATION ERROR: '
                'Reading Student Billing Input file' 
                x'0D0A0D0A' 'Return Code: ' IO-STATUS 
                   DELIMITED BY SIZE INTO FTPERROR-DIALOG
         PERFORM 9000-ERROR-SCREEN    THRU 9000-EXIT         
         PERFORM 9800-TERMINATION     THRU 9800-EXIT 
         MOVE 'E'                     TO VER-RESULT
         GOBACK   
       END-IF  

       IF BL-TRAIL-STUDENT-ID = 999999999 
         ADD BL-TRAIL-RECORD-CNT        TO WS-TRAILER-COUNT    
         PERFORM 6000-DISPLAY-LOG-COUNT THRU 6000-EXIT
         MOVE SPACES                    TO HOLD-SUBMIT-DATE
       ELSE
         IF BL-TRAIL-STUDENT-ID IS NOT EQUAL TO ZERO   
           IF HOLD-SUBMIT-DATE = SPACES
             MOVE BL-SUBMIT-DTE         TO HOLD-SUBMIT-DATE
           ELSE
             IF BL-SUBMIT-DTE NOT EQUAL HOLD-SUBMIT-DATE
               SUBTRACT 1               FROM WS-SUBMITTAL-COUNT
               PERFORM 6000-DISPLAY-LOG-COUNT THRU 6000-EXIT
               MOVE BL-SUBMIT-DTE       TO HOLD-SUBMIT-DATE   
             END-IF
           END-IF   
         END-IF
       END-IF  

       READ INSBFILE
     END-PERFORM.

     MOVE 100                        TO TRANSDLG-PROGRESS.
     PERFORM 1000-DISPLAY-PROGRESS   THRU 1000-EXIT.
     CALL 'S_Sleep' USING BY VALUE SLEEP-DELAY. 
                            
* PERFORM RECORD COUNT VERIFICATION
     IF WS-TRAILER-COUNT IS NOT EQUAL TO WS-RECORD-COUNT  
       IF VER-TRANTYPE = 1
         STRING 'Student Billing record count in trailer does' 
                x'0D0A' 'not equal the number of records read!'
                x'00' DELIMITED BY SIZE INTO FTPERROR-DIALOG
         PERFORM 9000-ERROR-SCREEN    THRU 9000-EXIT         
       END-IF  
       MOVE 'E'                     TO VER-RESULT
     END-IF.  
 0200-EXIT.
     EXIT.
*
 1000-DISPLAY-PROGRESS.  
     
     STRING 'Verifying record count and structure of ' 
                        DELIMITED BY SIZE
            WS-FILEDESC DELIMITED BY x'00' 
            ' file.'    DELIMITED BY SIZE
       INTO TRANSDLG-TITLE.     
 
     DIVIDE WS-RECORD-COUNT BY WS-TOTAL-RECORDS 
                                GIVING WS-TRANS-PROGRESS.   
     MULTIPLY WS-TRANS-PROGRESS BY 100 
                                GIVING TRANSDLG-PROGRESS ROUNDED.
             
     MOVE WS-RECORD-COUNT       TO WS-RECORD-COUNT-X.
     STRING 'Verifying: Processing record - ' DELIMITED BY SIZE
            WS-RECORD-COUNT-X x'00' DELIMITED BY SIZE
                                   INTO TRANSDLG-PROGRESS-TEXT.  
     
     SET TRANSDLG-DO-DISPLAY-AND-RETURN  TO TRUE. 
     CALL 'GS' USING TRANSDLG-1
                     TRANSDLG-2
                     TRANSDLG-3
                     TRANSDLG-4   
     END-CALL.                
 
 1000-EXIT.
     EXIT.
*
 6000-DISPLAY-LOG-COUNT.
     MOVE WS-SUBMITTAL-COUNT           TO WS-RECORD-COUNT-X.   
     STRING FTPSCRN-DIALOG DELIMITED BY x'00'
            '  (' WS-RECORD-COUNT-X ' data records submitted'  
            ' to DHS on ' SUBMIT-MM '/' SUBMIT-DD
            '/' SUBMIT-YYYY ')' X'0D0A' X'00'
                       DELIMITED BY SIZE INTO FTPSCRN-DIALOG.  
     MOVE 1                            TO WS-SUBMITTAL-COUNT.
 6000-EXIT.
     EXIT.
*        
 9000-ERROR-SCREEN.
     CALL 'GS' USING FTPERROR-1
                     FTPERROR-2
                     FTPERROR-3
                     FTPERROR-4.   
 9000-EXIT.
     EXIT.
*
 9500-INITIALIZATION.
     MOVE ZEROS                    TO WS-RECORD-COUNT 
                                      WS-TRAILER-COUNT
                                      WS-HOUR-COUNT
                                      WS-MINUTE-COUNT.  
*                            
     OPEN INPUT SETTINGS.  
     READ SETTINGS.    
     MOVE FILETYPE-DESCRIPTIONS       TO FtpTypes-Screen-Fields.
     CLOSE SETTINGS. 
*
     MOVE SPACE                         TO VER-RESULT. 
*
     MOVE Z'File Verification'          TO N--PANEL-TITLE.
*       
     STRING Filetype-Desc(VER-FILETYPE) x'00'   
                    DELIMITED BY SIZE INTO WS-FILEDESC.
 9500-EXIT.
     EXIT.
*
 9800-TERMINATION.  
     IF PSMRTFBL-OPEN
       CLOSE INSBFILE
       MOVE 'N'   TO PSMRTFBL-OPEN-IND
     END-IF.  
 9800-EXIT.
     EXIT.
     
